# 웹소켓 이벤트

### HEARTBEAT_ACK

```json5
{
    "op": "HEARTBEAT_ACK",
    "d": 1596417937 // 타임스탬프
}
```

### STAT

```json
{
    "UsedMemory": 0,
    "TotalMemory": 0,
    "ProcessLoad": 0,
    "TotalLoad": 0,
    "Cores": 0,
    "Threads": 0,
    "NetworkInbound": 0,
    "NetworkOutbound": 0,
    "TotalPlayer": 0
}
```

### IDENTIFIED

```json
{
    "op": "IDENTIFIED",
    "d": "ClientManager initialized."
}
```

## Audio Player

음성채널에 연결된 이후에만 전송됩니다.

### VC_CREATED

```json
{
    "op": "VC_CREATED",
    "d": {
        "guild_id": "오디오 플레이어의 서버 ID"
    }
}
```

### VC_DESTROYED

```json
{
    "op": "VC_DESTROYED",
    "d": {
        "guild_id": "오디오 플레이어의 서버 ID"
    }
}
```

### setVolume

```json5
{
    "op": "setVolume",
    "d": {
        "guild_id": "오디오 플레이어의 서버 ID",
        "volume": 1.0 // 0.0 ~ 2.0
    }
}
```

### setCrossfade

```json
{
    "op": "setCrossfade",
    "d": {
        "guild_id": "오디오 플레이어의 서버 ID",
        "crossfade": 10.0
    }
}
```

### setAutoplay

```json
{
    "op": "setAutoplay",
    "d": {
        "guild_id": "오디오 플레이어의 서버 ID",
        "autoplay": true
    }
}
```

### setFilter

```json5
{
    "op": "setFilter",
    "d": {
        "guild_id": "오디오 플레이어의 서버 ID",
        "filter": {
            // libavfilter 객체
        }
    }
}
```
### getSource

```json5
{
    "op": "getSource",
    "d": {
        "guild_id": "오디오 플레이어의 서버 ID",
        "source": {
            // Source 객체
        }
    }
}
```

### loadSource

```json5
{
    "op": "loadSource",
    "d": {
        "guild_id": "오디오 플레이어의 서버 ID",
        "source": {
            // Source 객체
        }
    }
}
```

### putSource

```json5
{
    "op": "putSong",
    "d": {
        "guild_id": "오디오 플레이어의 서버 ID",
        "source": {
            // Source 객체
        }
    }
}
```

### REQUIRE_NEXT_SOURCE

**만약 `autoplay` 가 활성화되있다면, 추천 영상이 이 이벤트 이후에 자동으로 추가됩니다.**

```json5
{
    "op": "REQUIRE_NEXT_SOURCE",
    "d": {
        "guild_id": "오디오 플레이어의 서버 ID",
        "current": {
            // Source 객체
        }
    }
}
```

### skip

```json
{
    "op": "skip",
    "d": {
        "guild_id": "오디오 플레이어의 서버 ID",
        "remain": 0
    }
}
```

### seek

```json
{
    "op": "seek",
    "d": {
        "guild_id": "오디오 플레이어의 서버 ID",
        "offset": 0
    }
}
```

### Queue

```json5
{
    "op": "Queue",
    "d": {
        "guild_id": "오디오 플레이어의 서버 ID",
        "entries": [
            // source 객체
        ]
    }
}
```

### State

```json5
{
    "op": "getState",
    "d": {
        "id": "...",
        "guild_id": "...",
        "channel_id": "...",
        "state": "...",
        "current": {},
        "duration": 0.0,
        "position": 0.0,
        "remain": 0.0,
        "options": {
            "autoplay": true,
            "volume": 1.0,
            "crossfade": 10.0,
            "filter": {}
        }
    }
}
```

### pause

```json
{
    "op": "pause",
    "d": {
        "guild_id": "오디오 플레이어의 서버 ID",
        "state": "paused"
    }
}
```

### resume

```json
{
    "op": "pause",
    "d": {
        "guild_id": "오디오 플레이어의 서버 ID",
        "state": "playing"
    }
}
```

### shuffle

```json5
{
    "op": "shuffle",
    "d": {
        "guild_id": "오디오 플레이어의 서버 ID",
        "entries": [
            // Source 객체
        ]
    }
}
```

### remove

```json5
{
    "op": "remove",
    "d": {
        "guild_id": "오디오 플레이어의 서버 ID",
        "removed": {
            // Source 객체
        },
        "entries": [
            // Source 객체
        ]
    }
}
```

### requestSubtitle

```json
{
    "op": "requestSubtitle",
    "d": {
        "guild_id": "오디오 플레이어의 서버 ID",
        "identify": "58b8b68f-e938-4699-b4ad-ffa262bf903d",
        "url": "..."
    }
}
```

### Subtitle

```json
{
    "op": "Subtitle",
    "d": {
        "guild_id": "오디오 플레이어의 서버 ID",
        "identify": "58b8b68f-e938-4699-b4ad-ffa262bf903d",
        "previous": "이전 자막",
        "current": "현재 자막",
        "next": "다음 자막"
    }
}
```

### subtitleDone

```json
{
    "op": "subtitleDone",
    "d": {
        "guild_id": "오디오 플레이어의 서버 ID",
        "identify": "58b8b68f-e938-4699-b4ad-ffa262bf903d",
        "url": "..."
    }
}
```
